initdb.sh 19.0 KB
Newer Older
M
 
Marc G. Fournier 已提交
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28
#!/bin/sh
#-------------------------------------------------------------------------
#
# initdb.sh--
#     Create (initialize) a Postgres database system.  
# 
#     A database system is a collection of Postgres databases all managed
#     by the same postmaster.  
#
#     To create the database system, we create the directory that contains
#     all its data, create the files that hold the global classes, create
#     a few other control files for it, and create one database:  the
#     template database.
#
#     The template database is an ordinary Postgres database.  Its data
#     never changes, though.  It exists to make it easy for Postgres to 
#     create other databases -- it just copies.
#
#     Optionally, we can skip creating the database system and just create
#     (or replace) the template database.
#
#     To create all those classes, we run the postgres (backend) program and
#     feed it data from bki files that are in the Postgres library directory.
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
29
#    $Header: /cvsroot/pgsql/src/bin/initdb/Attic/initdb.sh,v 1.99 2000/07/03 20:48:46 petere Exp $
B
Bruce Momjian 已提交
30 31 32
#
#-------------------------------------------------------------------------

33
exit_nicely(){
B
Bruce Momjian 已提交
34
    stty echo > /dev/null 2>&1
B
Bruce Momjian 已提交
35 36
    echo
    echo "$CMDNAME failed."
37
    if [ "$noclean" -eq 0 ]; then
B
Bruce Momjian 已提交
38
        echo "Removing $PGDATA."
39
        rm -rf "$PGDATA" || echo "Failed."
40 41
        echo "Removing temp file $TEMPFILE."
        rm -rf "$TEMPFILE" || echo "Failed."
B
Bruce Momjian 已提交
42 43 44 45 46 47 48 49 50
    else
        echo "Data directory $PGDATA will not be removed at user's request."
    fi
    exit 1
}


CMDNAME=`basename $0`

51 52 53 54 55
if [ "$TMPDIR" ]; then
    TEMPFILE="$TMPDIR/initdb.$$"
else
    TEMPFILE="/tmp/initdb.$$"
fi
B
Bruce Momjian 已提交
56

P
Peter Eisentraut 已提交
57 58 59 60 61 62 63 64 65 66 67 68

# Check for echo -n vs echo \c
if echo '\c' | grep -s c >/dev/null 2>&1
then
    ECHO_N="echo -n"
    ECHO_C=""
else
    ECHO_N="echo"
    ECHO_C='\c'
fi


B
Bruce Momjian 已提交
69 70 71
#
# Find out where we're located
#
72 73
if echo "$0" | grep '/' > /dev/null 2>&1 
then
B
Bruce Momjian 已提交
74 75 76 77
        # explicit dir name given
        PGPATH=`echo $0 | sed 's,/[^/]*$,,'`       # (dirname command is not portable)
else
        # look for it in PATH ('which' command is not portable)
B
Bruce Momjian 已提交
78 79
        for dir in `echo "$PATH" | sed 's/:/ /g'`
	do
B
Bruce Momjian 已提交
80 81
                # empty entry in path means current dir
                [ -z "$dir" ] && dir='.'
82
                if [ -f "$dir/$CMDNAME" ]
B
Bruce Momjian 已提交
83
		then
B
Bruce Momjian 已提交
84 85 86 87 88 89 90
                        PGPATH="$dir"
                        break
                fi
        done
fi

# Check if needed programs actually exist in path
91
for prog in postgres pg_id
B
Bruce Momjian 已提交
92
do
93
        if [ ! -x "$PGPATH/$prog" ]
B
Bruce Momjian 已提交
94
	then
B
Bruce Momjian 已提交
95 96 97 98 99 100 101 102 103 104
                echo "The program $prog needed by $CMDNAME could not be found. It was"
                echo "expected at:"
                echo "    $PGPATH/$prog"
                echo "If this is not the correct directory, please start $CMDNAME"
                echo "with a full search path. Otherwise make sure that the program"
                echo "was installed successfully."
                exit 1
        fi
done

105 106 107 108 109 110 111 112 113 114 115 116 117 118 119

# Gotta wait for pg_id existence check above
EffectiveUser=`$PGPATH/pg_id -n -u`
if [ -z "$EffectiveUser" ]; then
    echo "Could not determine current user name. You are really hosed."
    exit 1
fi

if [ `$PGPATH/pg_id -u` -eq 0 ]
then
    echo "You cannot run $CMDNAME as root. Please log in (using, e.g., 'su')"
    echo "as the (unprivileged) user that will own the server process."
    exit 1
fi

120 121 122 123 124 125 126
# Replaced at build time
VERSION=__VERSION__
short_version=`echo $VERSION | sed -e 's!^\([0-9][0-9]*\.[0-9][0-9]*\).*!\1!'`
if [ x"$short_version" = x"" ] ; then
  echo "$CMDNAME: bug: version number is out of format"
  exit 1
fi
127

B
Bruce Momjian 已提交
128 129
# 0 is the default (non-)encoding
MULTIBYTEID=0
P
Peter Eisentraut 已提交
130
# This is placed here by configure --enable-multibyte[=XXX].
B
Bruce Momjian 已提交
131 132 133 134 135 136
MULTIBYTE=__MULTIBYTE__

# Set defaults:
debug=0
noclean=0
template_only=0
137
show_setting=0
B
Bruce Momjian 已提交
138 139 140 141 142

# Note: There is a single compelling reason that the name of the database
#       superuser be the same as the Unix user owning the server process:
#       The single user postgres backend will only connect as the database
#       user with the same name as the Unix user running it. That's
143
#       a security measure.
144
POSTGRES_SUPERUSERNAME="$EffectiveUser"
145
POSTGRES_SUPERUSERID=`$PGPATH/pg_id -u`
B
Bruce Momjian 已提交
146

147
while [ "$#" -gt 0 ]
B
Bruce Momjian 已提交
148 149 150 151 152 153
do
    case "$1" in
        --help|-\?)
                usage=t
                break
                ;;
154 155 156 157
        --version)
                echo "initdb (PostgreSQL) $VERSION"
                exit 0
                ;;
B
Bruce Momjian 已提交
158 159 160 161
        --debug|-d)
                debug=1
                echo "Running with debug mode on."
                ;;
162 163 164
        --show|-s)
        	show_setting=1
        	;;        
B
Bruce Momjian 已提交
165 166 167 168 169 170 171 172
        --noclean|-n)
                noclean=1
                echo "Running with noclean mode on. Mistakes will not be cleaned up."
                ;;
        --template|-t)
                template_only=1
                echo "Updating template1 database only."
                ;;
173
# The sysid of the database superuser. Can be freely changed.
B
Bruce Momjian 已提交
174 175 176 177 178 179 180 181 182 183
        --sysid|-i)
                POSTGRES_SUPERUSERID="$2"
                shift;;
        --sysid=*)
                POSTGRES_SUPERUSERID=`echo $1 | sed 's/^--sysid=//'`
                ;;
        -i*)
                POSTGRES_SUPERUSERID=`echo $1 | sed 's/^-i//'`
                ;;
# The default password of the database superuser.
P
Peter Eisentraut 已提交
184 185 186
# Make initdb prompt for the default password of the database superuser.
        --pwprompt|-W)
                PwPrompt=1
B
Bruce Momjian 已提交
187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211
                ;;
# Directory where to install the data. No default, unless the environment
# variable PGDATA is set.
        --pgdata|-D)
                PGDATA="$2"
                shift;;
        --pgdata=*)
                PGDATA=`echo $1 | sed 's/^--pgdata=//'`
                ;;
        -D*)
                PGDATA=`echo $1 | sed 's/^-D//'`
                ;;
# The directory where the database templates are stored (traditionally in
# $prefix/lib). This is now autodetected for the most common layouts.
        --pglib|-L)
                PGLIB="$2"
                shift;;
        --pglib=*)
                PGLIB=`echo $1 | sed 's/^--pglib=//'`
                ;;
        -L*)
                PGLIB=`echo $1 | sed 's/^-L//'`
                ;;
# The encoding of the template1 database. Defaults to what you chose
# at configure time. (see above)
212
        --encoding|-E)
B
Bruce Momjian 已提交
213 214
                MULTIBYTE="$2"
                shift;;
P
Peter Eisentraut 已提交
215 216
        --encoding=*)
                MULTIBYTE=`echo $1 | sed 's/^--encoding=//'`
B
Bruce Momjian 已提交
217
                ;;
218 219
        -E*)
                MULTIBYTE=`echo $1 | sed 's/^-E//'`
B
Bruce Momjian 已提交
220
                ;;
P
Peter Eisentraut 已提交
221 222 223 224 225
	-*)
		echo "$CMDNAME: invalid option: $1"
		echo "Try -? for help."
		exit 1
		;;
B
Bruce Momjian 已提交
226
        *)
P
Peter Eisentraut 已提交
227
                PGDATA=$1
B
Bruce Momjian 已提交
228 229 230 231 232
                ;;
    esac
    shift
done

P
Peter Eisentraut 已提交
233 234 235 236 237 238 239
if [ "$usage" ]; then
        echo "initdb initialized a PostgreSQL database."
 	echo
 	echo "Usage:"
        echo "  $CMDNAME [options] datadir"
 	echo
        echo "Options:"
P
Peter Eisentraut 已提交
240
        echo " [-D, --pgdata] <datadir>     Location for this database"
P
Peter Eisentraut 已提交
241
        echo "  -W, --pwprompt              Prompt for a password for the new superuser's"
242 243
 	if [ -n "$MULTIBYTE" ]
	then 
244
 		echo "  -E, --encoding <encoding>   Set the default multibyte encoding for new databases"
B
Bruce Momjian 已提交
245
	fi
P
Peter Eisentraut 已提交
246 247
        echo "  -i, --sysid <sysid>         Database sysid for the superuser"
        echo "Less commonly used options: "
P
Peter Eisentraut 已提交
248
        echo "  -L, --pglib <libdir>        Where to find the input files"
P
Peter Eisentraut 已提交
249 250 251
        echo "  -t, --template              Re-initialize template database only"
        echo "  -d, --debug                 Generate lots of debugging output"
        echo "  -n, --noclean               Do not clean up after errors"
252
 	echo
253
        echo "Report bugs to <pgsql-bugs@postgresql.org>."
254
 	exit 0
B
Bruce Momjian 已提交
255 256 257 258 259 260
fi

#-------------------------------------------------------------------------
# Resolve the multibyte encoding name
#-------------------------------------------------------------------------

261 262
if [ "$MULTIBYTE" ]
then
P
Peter Eisentraut 已提交
263
	MULTIBYTEID=`$PGPATH/pg_encoding $MULTIBYTE 2> /dev/null`
264
        if [ "$?" -ne 0 ]
B
Bruce Momjian 已提交
265
	then
P
Peter Eisentraut 已提交
266 267 268 269
                echo "$CMDNAME: pg_encoding failed"
                echo
                echo "Perhaps you did not configure PostgreSQL for multibyte support or"
                echo "the program was not successfully installed."
B
Bruce Momjian 已提交
270 271
                exit 1
        fi
272 273
	if [ -z "$MULTIBYTEID" ]
	then
P
Peter Eisentraut 已提交
274
		echo "$CMDNAME: $MULTIBYTE is not a valid encoding name"
B
Bruce Momjian 已提交
275 276 277 278 279 280 281 282 283
		exit 1
	fi
fi


#-------------------------------------------------------------------------
# Make sure he told us where to build the database system
#-------------------------------------------------------------------------

284 285
if [ -z "$PGDATA" ]
then
B
Bruce Momjian 已提交
286 287 288 289 290 291 292 293 294 295
    echo "$CMDNAME: You must identify where the the data for this database"
    echo "system will reside.  Do this with either a --pgdata invocation"
    echo "option or a PGDATA environment variable."
    echo
    exit 1
fi

# The data path must be absolute, because the backend doesn't like
# '.' and '..' stuff. (Should perhaps be fixed there.)

296 297
echo "$PGDATA" | grep '^/' > /dev/null 2>&1
if [ "$?" -ne 0 ]
298
then
P
Peter Eisentraut 已提交
299
    echo "$CMDNAME: data path must be specified as an absolute path"
B
Bruce Momjian 已提交
300 301 302 303 304 305 306 307
    exit 1
fi


#-------------------------------------------------------------------------
# Find the input files
#-------------------------------------------------------------------------

308 309
if [ -z "$PGLIB" ]
then
B
Bruce Momjian 已提交
310 311
        for dir in "$PGPATH/../lib" "$PGPATH/../lib/pgsql"
	do
312
                if [ -f "$dir/global1.bki.source" ]
B
Bruce Momjian 已提交
313
		then
314
                        PGLIB="$dir"
B
Bruce Momjian 已提交
315 316 317 318 319
                        break
                fi
        done
fi

320 321
if [ -z "$PGLIB" ]
then
B
Bruce Momjian 已提交
322 323 324 325 326 327 328
        echo "$CMDNAME: Could not find the \"lib\" directory, that contains"
        echo "the files needed by initdb. Please specify it with the"
        echo "--pglib option."
        exit 1
fi


329 330 331
TEMPLATE="$PGLIB"/local1_template1.bki.source
GLOBAL="$PGLIB"/global1.bki.source
PG_HBA_SAMPLE="$PGLIB"/pg_hba.conf.sample
332
POSTGRESQL_CONF_SAMPLE="$PGLIB"/postgresql.conf.sample
B
Bruce Momjian 已提交
333

334 335
TEMPLATE_DESCR="$PGLIB"/local1_template1.description
GLOBAL_DESCR="$PGLIB"/global1.description
B
Bruce Momjian 已提交
336

337
if [ "$show_setting" -eq 1 ]
338 339 340 341 342 343 344 345 346 347 348 349 350 351 352
then
	echo
	echo "The initdb setting:"
 	echo
 	echo "  DATADIR:        $PGDATA"
 	echo "  PGLIB:          $PGLIB"
 	echo "  PGPATH:         $PGPATH"
 	echo "  TEMPFILE:       $TEMPFILE"
 	echo "  MULTIBYTE:      $MULTIBYTE"
 	echo "  MULTIBYTEID:    $MULTIBYTEID"
 	echo "  SUPERUSERNAME:  $POSTGRES_SUPERUSERNAME"
 	echo "  SUPERUSERID:    $POSTGRES_SUPERUSERID"
 	echo "  TEMPLATE:       $TEMPLATE"	 
	echo "  GLOBAL:         $GLOBAL"
	echo "  PG_HBA_SAMPLE:  $PG_HBA_SAMPLE"
353
        echo "  POSTGRESQL_CONF_SAMPLE: $POSTGRESQL_CONF_SAMPLE"
354 355 356 357 358 359
	echo "  TEMPLATE_DESCR: $TEMPLATE_DESCR"
	echo "  GLOBAL_DESCR:   $GLOBAL_DESCR"
	echo 
	exit 0
fi

B
Bruce Momjian 已提交
360 361
for PREREQ_FILE in "$TEMPLATE" "$GLOBAL" "$PG_HBA_SAMPLE"
do
362 363
    if [ ! -f "$PREREQ_FILE" ]
	then 
B
Bruce Momjian 已提交
364 365 366 367 368 369 370 371 372
        echo "$CMDNAME does not find the file '$PREREQ_FILE'."
        echo "This means you have a corrupted installation or identified the"
        echo "wrong directory with the --pglib invocation option."
        exit 1
    fi
done

[ "$debug" -ne 0 ] && echo "$CMDNAME: Using $TEMPLATE as input to create the template database."

373 374
if [ "$template_only" -eq 0 ]
then
B
Bruce Momjian 已提交
375 376
    [ "$debug" -ne 0 ] && echo "$CMDNAME: Using $GLOBAL as input to create the global classes."
    [ "$debug" -ne 0 ] && echo "$CMDNAME: Using $PG_HBA_SAMPLE as default authentication control file."
B
Bruce Momjian 已提交
377
fi
B
Bruce Momjian 已提交
378

B
Bruce Momjian 已提交
379
trap 'echo "Caught signal." ; exit_nicely' 1 2 3 15
B
Bruce Momjian 已提交
380

381 382 383 384
# Let's go
echo "This database system will be initialized with username \"$POSTGRES_SUPERUSERNAME\"."
echo "This user will own all the data files and must also own the server process."
echo
B
Bruce Momjian 已提交
385

M
 
Marc G. Fournier 已提交
386 387 388 389 390 391 392
# -----------------------------------------------------------------------
# Create the data directory if necessary
# -----------------------------------------------------------------------

# umask must disallow access to group, other for files and dirs
umask 077

393 394 395
if [ -f "$PGDATA"/PG_VERSION ]
then
    if [ "$template_only" -eq 0 ]
B
Bruce Momjian 已提交
396
    then
397 398
        echo "$CMDNAME: The file $PGDATA/PG_VERSION already exists."
        echo "This probably means initdb has already been run and the"
M
 
Marc G. Fournier 已提交
399 400
        echo "database system already exists."
        echo 
401 402
        echo "If you want to create a new database system, either remove"
        echo "the directory $PGDATA or run initdb with a --pgdata argument"
M
 
Marc G. Fournier 已提交
403 404 405 406
        echo "other than $PGDATA."
        exit 1
    fi
else
407 408
    if [ ! -d "$PGDATA" ]
	then
409
        echo "Creating directory $PGDATA"
410
        mkdir "$PGDATA" || exit_nicely
411
    else
412
        echo "Fixing permissions on existing directory $PGDATA"
413
	chmod go-rwx "$PGDATA" || exit_nicely
M
 
Marc G. Fournier 已提交
414
    fi
415

416 417
    if [ ! -d "$PGDATA"/base ]
	then
418
        echo "Creating directory $PGDATA/base"
419
        mkdir "$PGDATA"/base || exit_nicely
M
 
Marc G. Fournier 已提交
420
    fi
421 422 423 424 425
    if [ ! -d "$PGDATA"/global ]
    then
        echo "Creating directory $PGDATA/global"
        mkdir "$PGDATA"/global || exit_nicely
    fi
426
    if [ ! -d "$PGDATA"/pg_xlog ]
B
Bruce Momjian 已提交
427
    then
428
        echo "Creating directory $PGDATA/pg_xlog"
429
        mkdir "$PGDATA"/pg_xlog || exit_nicely
430
    fi
M
 
Marc G. Fournier 已提交
431 432 433 434 435 436
fi

#----------------------------------------------------------------------------
# Create the template1 database
#----------------------------------------------------------------------------

437 438
rm -rf "$PGDATA"/base/template1 || exit_nicely
mkdir "$PGDATA"/base/template1 || exit_nicely
M
 
Marc G. Fournier 已提交
439

440 441
if [ "$debug" -eq 1 ]
then
M
 
Marc G. Fournier 已提交
442 443 444 445 446 447
    BACKEND_TALK_ARG="-d"
else
    BACKEND_TALK_ARG="-Q"
fi

BACKENDARGS="-boot -C -F -D$PGDATA $BACKEND_TALK_ARG"
448
FIRSTRUN="-boot -x -C -F -D$PGDATA $BACKEND_TALK_ARG"
M
 
Marc G. Fournier 已提交
449

B
Bruce Momjian 已提交
450
echo "Creating template database in $PGDATA/base/template1"
451
[ "$debug" -ne 0 ] && echo "Running: $PGPATH/postgres $FIRSTRUN template1"
M
 
Marc G. Fournier 已提交
452

453
cat "$TEMPLATE" \
454
| sed -e "s/PGUID/$POSTGRES_SUPERUSERID/g" \
455
| "$PGPATH"/postgres $FIRSTRUN template1 \
456
|| exit_nicely
M
 
Marc G. Fournier 已提交
457

458
echo $short_version > "$PGDATA"/base/template1/PG_VERSION || exit_nicely
M
 
Marc G. Fournier 已提交
459 460 461 462 463

#----------------------------------------------------------------------------
# Create the global classes, if requested.
#----------------------------------------------------------------------------

464 465
if [ "$template_only" -eq 0 ]
then
466
    echo "Creating global relations in $PGDATA/global"
467
    [ "$debug" -ne 0 ] && echo "Running: $PGPATH/postgres $BACKENDARGS template1"
M
 
Marc G. Fournier 已提交
468

469
    cat "$GLOBAL" \
470 471
    | sed -e "s/POSTGRES/$POSTGRES_SUPERUSERNAME/g" \
          -e "s/PGUID/$POSTGRES_SUPERUSERID/g" \
472
    | "$PGPATH"/postgres $BACKENDARGS template1 \
473
    || exit_nicely
M
 
Marc G. Fournier 已提交
474

475
    echo $short_version > "$PGDATA/PG_VERSION" || exit_nicely
M
 
Marc G. Fournier 已提交
476

477
    cp "$PG_HBA_SAMPLE" "$PGDATA"/pg_hba.conf     || exit_nicely
478
    cp "$POSTGRESQL_CONF_SAMPLE" "$PGDATA"/postgresql.conf || exit_nicely
479
    chmod 0600 "$PGDATA"/pg_hba.conf "$PGDATA"/postgresql.conf
M
 
Marc G. Fournier 已提交
480

481
    echo "Adding template1 database to pg_database"
M
 
Marc G. Fournier 已提交
482

483
    echo "open pg_database" > "$TEMPFILE"
484
    echo "insert (template1 $POSTGRES_SUPERUSERID $MULTIBYTEID template1)" >> $TEMPFILE
485 486
    #echo "show" >> "$TEMPFILE"
    echo "close pg_database" >> "$TEMPFILE"
M
 
Marc G. Fournier 已提交
487

488
    [ "$debug" -ne 0 ] && echo "Running: $PGPATH/postgres $BACKENDARGS template1 < $TEMPFILE"
M
 
Marc G. Fournier 已提交
489

490
    "$PGPATH"/postgres $BACKENDARGS template1 < "$TEMPFILE"
491
    # Gotta remove that temp file before exiting on error.
492
    retval="$?"
493
    rm -f "$TEMPFILE" || exit_nicely
494
    [ "$retval" -ne 0 ] && exit_nicely
M
 
Marc G. Fournier 已提交
495 496 497 498
fi

echo

499
PGSQL_OPT="-o /dev/null -O -F -D$PGDATA"
M
 
Marc G. Fournier 已提交
500

B
Bruce Momjian 已提交
501 502
# Create a trigger so that direct updates to pg_shadow will be written
# to the flat password file pg_pwd
503 504
echo "CREATE TRIGGER pg_sync_pg_pwd AFTER INSERT OR UPDATE OR DELETE ON pg_shadow" \
     "FOR EACH ROW EXECUTE PROCEDURE update_pg_pwd()" \
505
     | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
B
Bruce Momjian 已提交
506

P
Peter Eisentraut 已提交
507 508
# needs to be done before alter user
echo "REVOKE ALL on pg_shadow FROM public" \
509
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
510

P
Peter Eisentraut 已提交
511 512 513
# set up password
if [ "$PwPrompt" ]; then
    $ECHO_N "Enter new superuser password: "$ECHO_C
B
Bruce Momjian 已提交
514
    stty -echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
515
    read FirstPw
B
Bruce Momjian 已提交
516
    stty echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
517 518
    echo
    $ECHO_N "Enter it again: "$ECHO_C
B
Bruce Momjian 已提交
519
    stty -echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
520
    read SecondPw
B
Bruce Momjian 已提交
521
    stty echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
522 523 524 525 526 527 528 529 530 531 532 533 534 535
    echo
    if [ "$FirstPw" != "$SecondPw" ]; then
        echo "Passwords didn't match."
        exit_nicely
    fi
    echo "ALTER USER \"$POSTGRES_SUPERUSERNAME\" WITH PASSWORD '$FirstPw'" \
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
    if [ ! -f $PGDATA/pg_pwd ]; then
        echo "The password file wasn't generated. Please report this problem."
        exit_nicely
    fi
    echo "Setting password"
fi

536 537

echo "Creating view pg_user."
538 539 540 541 542 543 544 545 546 547
echo "CREATE VIEW pg_user AS \
        SELECT \
            usename, \
            usesysid, \
            usecreatedb, \
            usetrace, \
            usesuper, \
            usecatupd, \
            '********'::text as passwd, \
            valuntil \
548
        FROM pg_shadow" \
549
        | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
550 551

echo "Creating view pg_rules."
552 553 554 555 556 557 558
echo "CREATE VIEW pg_rules AS \
        SELECT \
            C.relname AS tablename, \
            R.rulename AS rulename, \
	    pg_get_ruledef(R.rulename) AS definition \
	FROM pg_rewrite R, pg_class C \
	WHERE R.rulename !~ '^_RET' \
559
            AND C.oid = R.ev_class;" \
560
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
561 562

echo "Creating view pg_views."
563 564 565 566 567 568 569 570 571 572
echo "CREATE VIEW pg_views AS \
        SELECT \
            C.relname AS viewname, \
            pg_get_userbyid(C.relowner) AS viewowner, \
            pg_get_viewdef(C.relname) AS definition \
        FROM pg_class C \
        WHERE C.relhasrules \
            AND	EXISTS ( \
                SELECT rulename FROM pg_rewrite R \
                    WHERE ev_class = C.oid AND ev_type = '1' \
573
            )" \
574
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
575 576

echo "Creating view pg_tables."
577 578 579 580 581 582 583 584 585 586 587 588
echo "CREATE VIEW pg_tables AS \
        SELECT \
            C.relname AS tablename, \
	    pg_get_userbyid(C.relowner) AS tableowner, \
	    C.relhasindex AS hasindexes, \
	    C.relhasrules AS hasrules, \
	    (C.reltriggers > 0) AS hastriggers \
        FROM pg_class C \
        WHERE C.relkind IN ('r', 's') \
            AND NOT EXISTS ( \
                SELECT rulename FROM pg_rewrite \
                    WHERE ev_class = C.oid AND ev_type = '1' \
589
            )" \
590
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
591 592

echo "Creating view pg_indexes."
593 594 595 596 597 598 599
echo "CREATE VIEW pg_indexes AS \
        SELECT \
            C.relname AS tablename, \
	    I.relname AS indexname, \
            pg_get_indexdef(X.indexrelid) AS indexdef \
        FROM pg_index X, pg_class C, pg_class I \
	WHERE C.oid = X.indrelid \
600
            AND I.oid = X.indexrelid" \
601
        | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
602 603

echo "Loading pg_description."
604 605 606 607 608
echo "COPY pg_description FROM STDIN" > $TEMPFILE
cat "$TEMPLATE_DESCR" >> $TEMPFILE
cat "$GLOBAL_DESCR" >> $TEMPFILE

cat $TEMPFILE \
609
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
610
rm -f "$TEMPFILE" || exit_nicely
611

612 613
echo "Vacuuming database."
echo "VACUUM ANALYZE" \
614
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
615 616

echo
617
echo "Success. You can now start the database server using:"
618 619 620 621
echo ""
echo "	$PGPATH/postmaster -D $PGDATA"
echo "or"
echo "	$PGPATH/pg_ctl -D $PGDATA start"
622 623 624
echo

exit 0